if select(2, UnitClass('player')) ~= "HUNTER" then
	DisableAddOn("KingOfTheJungle")
	return
end
local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")
local PT = AceLibrary:GetInstance("PeriodicTable-3.0")
local BS = AceLibrary:GetInstance("Babble-Spell-2.2")
local FL = AceLibrary:GetInstance("FrameLib-1.0")
local PL = ParserLib:GetInstance("1.1")

KingOfTheJungle = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceDB-2.0","AceDebug-2.0", "AceEvent-2.0")

KingOfTheJungle:RegisterDB("KingOfTheJungleDB", "KingOfTheJungleDBPerChar")

KingOfTheJungle:RegisterDefaults('char', {
    msgInterval = 60,
	lastWarningTime = 0,
	buttonX = 100,
	buttonY = 0,
	buttonScale = 1.0,
	buttonPoint = FL.ANCHOR.CENTER,
	popupAnchor = FL.ANCHOR.RIGHT,
	popupGrowthDir = FL.ANCHOR.RIGHT,
	showUnknownFood = true,
	maxButtons = 10,
	enableMendPet = true,
})

KingOfTheJungle:RegisterDefaults('profile', {
	version = nil,
	foodlist = nil
})

function KingOfTheJungle:InitDB()	
	local convert = function(t_old)
		if t_old then
			local t = {}
			for k,v,s in PT:IterateSet(t_old) do
				local f = {}
				f["id"] = tonumber(k)
				if tonumber(v) then
					f["value"] = tonumber(v)
				else
					f["value"] = 0
				end
				f["selected"] = true
				
				table.insert(t,f)
			end
			
			table.sort(t, function (a,b) return a.value > b.value end)
			
			return t
		end
		
		return nil
	end
	
	if self.db.profile.foodlist == nil then
		self:Debug("Initializing Food DB")
		
		self.db.profile.foodlist = {}
		
		local foodtable = {
			[1] = {["text"] = "Food - Meat Raw", ["pt3"]= "Consumable.Food.Inedible.Meat", ["icon"] = "Interface\\Icons\\INV_Misc_Food_71", ["enabled"] = false},
			[2] = {["text"] = "Food - Meat Basic", ["pt3"]= "Consumable.Food.Edible.Meat.Basic", ["icon"] = "Interface\\Icons\\INV_Misc_Food_15", ["enabled"] = true},
			[3] = {["text"] = "Food - Meat Bonus", ["pt3"]= "Consumable.Food.Edible.Meat.Bonus", ["icon"] = "Interface\\Icons\\INV_Misc_Food_48", ["enabled"] = false},
			[4] = {["text"] = "Food - Bread Combo", ["pt3"]= "Consumable.Food.Edible.Bread.Combo", ["icon"] = "Interface\\Icons\\INV_Misc_Food_33", ["enabled"] = false},
			[5] = {["text"] = "Food - Bread Basic", ["pt3"]= "Consumable.Food.Edible.Bread.Basic", ["icon"] = "Interface\\Icons\\INV_Misc_Food_12", ["enabled"] = true},
			[6] = {["text"] = "Food - Bread Bonus", ["pt3"]= "Consumable.Food.Edible.Bread.Bonus", ["icon"] = "Interface\\Icons\\INV_Misc_Food_62", ["enabled"] = false},
			[7] = {["text"] = "Food - Bread Conjured", ["pt3"]= "Consumable.Food.Edible.Bread.Conjured", ["icon"] = "Interface\\Icons\\INV_Misc_Food_73CinnamonRoll", ["enabled"] = true},
			[8] = {["text"] = "Food - Cheese Basic", ["pt3"]= "Consumable.Food.Edible.Cheese.Basic", ["icon"] = "Interface\\Icons\\INV_Misc_Food_37", ["enabled"] = true},
			[9] = {["text"] = "Food - Cheese Bonus", ["pt3"]= "Consumable.Food.Edible.Cheese.Bonus", ["icon"] = "Interface\\Icons\\INV_Misc_Food_06", ["enabled"] = false},
			[10] = {["text"] = "Food - Fish Raw", ["pt3"]= "Consumable.Food.Inedible.Fish", ["icon"] = "Interface\\Icons\\INV_Misc_Fish_06", ["enabled"] = false},
			[11] = {["text"] = "Food - Fish Basic", ["pt3"]= "Consumable.Food.Edible.Fish.Basic", ["icon"] = "Interface\\Icons\\INV_Misc_Fish_07", ["enabled"] = true},
			[12] = {["text"] = "Food - Fish Bonus", ["pt3"]= "Consumable.Food.Edible.Fish.Bonus", ["icon"] = "Interface\\Icons\\INV_Misc_Fish_05", ["enabled"] = false},
			[13] = {["text"] = "Food - Fish Combo", ["pt3"]= "Consumable.Food.Edible.Fish.Combo", ["icon"] = "Interface\\Icons\\INV_Misc_Fish_13", ["enabled"] = false},
			[14] = {["text"] = "Food - Fruit Basic", ["pt3"]= "Consumable.Food.Edible.Fruit.Basic", ["icon"] = "Interface\\Icons\\INV_Misc_Food_20", ["enabled"] = true},
			[15] = {["text"] = "Food - Fruit Bonus", ["pt3"]= "Consumable.Food.Edible.Fruit.Bonus", ["icon"] = "Interface\\Icons\\INV_Misc_Food_58", ["enabled"] = false},
			[16] = {["text"] = "Food - Fruit Combo", ["pt3"]= "Consumable.Food.Edible.Fruit.Combo", ["icon"] = "Interface\\Icons\\INV_Misc_Food_42", ["enabled"] = false},
			[17] = {["text"] = "Food - Fungus Basic", ["pt3"]= "Consumable.Food.Edible.Fungus.Basic", ["icon"] = "Interface\\Icons\\INV_Mushroom_11", ["enabled"] = true},
			[18] = {["text"] = "Food - Fungus Bonus", ["pt3"]= "Consumable.Food.Edible.Fungus.Bonus", ["icon"] = "Interface\\Icons\\INV_Mushroom_01", ["enabled"] = false},
			[19] = {["text"] = "Food - Fungus Combo", ["pt3"]= "Consumable.Food.Edible.Fungus.Combo", ["icon"] = "Interface\\Icons\\INV_Misc_Herb_07", ["enabled"] = false},
		}

		for _,v in ipairs(foodtable) do
			self:Debug("Adding: "..v["text"])
			table.insert(self.db.profile.foodlist,{
				["diet"] = v["text"], 
				["list"] = convert(v["pt3"]),
				["icon"] = v["icon"],
				["selected"] = v["enabled"],
			})
		end
		self:Debug("Finished Food DB")
		self:Print(L["Resetting Food DB."])
	end
end

function KingOfTheJungle:tablecopy(t)
	if not t then
		return t
	end
	
	local tmp = {}
	for i,v in pairs(t) do
		if type(v) == table then
			tmp[i] = self:tablecopy(v)
		else
			tmp[i] = v
		end		
	end
	return tmp
end

function KingOfTheJungle:OverrideBindings()
	local key1, key2 = GetBindingKey("KOTJFeedButton")
	if key1 then
		SetOverrideBindingClick(self.feedButton, false, key1, "KOTJFeedButton") 
	end
	if key2 then
		SetOverrideBindingClick(self.feedButton, false, key2, "KOTJFeedButton") 
	end
	SaveBindings(GetCurrentBindingSet())
end

function KingOfTheJungle:OnInitialize()
	local _,class = UnitClass('player')
	BINDING_HEADER_KingOfTheJungle = L["King of the Jungle"]	
	BINDING_NAME_KOTJFeedButton = BS["Feed Pet"]

	local options = { 
		type = "group",
			args = {				
				menu = {
					name = L["Show Config"], desc = L["Shows Config Screen"], type = 'execute',
					func = function() self:KOTJUI_Show() end
				},
				resetdb = {
					name = L["Reset Food"], desc = L["Reset Food Database"], type = 'execute',
					func = function() 
						self.db.profile.foodlist = nil  
						self.db.profile.version = select(2, PT:GetLibraryVersion())
						self:InitDB()
					end
				},
				mendpet = {
					type = "toggle",
					name = "Mend Pet",
					desc = "enable Mend Pet in combat",
					get = function() return KingOfTheJungle.db.char.enableMendPet end,
					set = function(v) KingOfTheJungle.db.char.enableMendPet = v end,
				}
			}
		}

	KingOfTheJungle:RegisterChatCommand({"/kotj"}, options)
	
	if not self.db.profile.version or (self.db.profile.version < select(2, PT:GetLibraryVersion())) then
		self:Print(L["The Food DB got updated, please upgrade to get new food data (/kotj resetdb)."])
	end
	
	self:InitDB()
	
	self.mendpetid = self:ScanSpellBook(BS["Improved Mend Pet"])
	if not self.mendpetid then
		self.mendpetid = self:ScanSpellBook(BS["Mend Pet"])
	end
	
	
	
	self:Print("Rawrrrrrr...")
end

function KingOfTheJungle:ScanSpellBook(s)
	local i = 1
	local tmp_id = nil
	local tmp_rank = 0
	
	while true do
		local spell, rank = GetSpellName(i, BOOKTYPE_SPELL)		
		if (not spell) then
			break
		end
		if spell == s then
			rank = tonumber(string.sub(rank, -1))
			if rank and rank > tmp_rank then
				tmp_rank = rank
				tmp_id = i
--~ 				self:Print(i..":"..spell..":"..rank)
			end
		end
		i = i + 1
	end
	return tmp_id
end

function KingOfTheJungle:OnEnable()	
	self.feedButton = FL:CreateFrame({frame = FL.UIOBJECT.BUTTON, name = "KOTJFeedButton", parent = UIParent, inherits = "SecureActionButtonTemplate,ActionButtonTemplate,SecureAnchorEnterTemplate",
										setpoint = {point = self.db.char.buttonPoint, x = self.db.char.buttonX, y = self.db.char.buttonY},
										scale = self.db.char.buttonScale, movable = true})
	
	self.feedButton.texture = FL:CreateTexture({parent = self.feedButton, layer = FL.LAYER.BACKGROUND, texture = "Interface\\Icons\\Ability_Hunter_BeastTraining",
										setpoint = {frame = self.feedButton}})
	
	self.feedButton:RegisterForDrag("LeftButton")

	self.feedButton:SetAttribute("unit", "player")
	self.feedButton:SetAttribute("type", "spell")

	self.feedButton:SetAttribute("spell", BS["Feed Pet"])
	self.feedButton:SetAttribute("target-item", ATTRIBUTE_NOOP)

	self.feedButton:SetAttribute("*childraise-OnEnter", true)
	self.feedButton:SetAttribute("*childstate-OnEnter", "enter")
	self.feedButton:SetAttribute("*childstate-OnLeave", "leave")
		
	self.feedButton:SetScript("OnEnter", function()
--~ 	added for SecureAnchorOnEnterTemplate, cause we define our own enter we need to make sure events get triggered
--~   	code copied from SecureTemplates.xml
		self.feedButton:SetAttribute("_entered", true);
		SecureStateAnchor_RunChild(self.feedButton, "OnEnter", "onenterbutton");
--~ 		
		local itemlink = self:FeedPet()
		GameTooltip:SetOwner(this,"ANCHOR_RIGHT")
		if InCombatLockdown() and self.db.char.enableMendPet then
			if self.mendpetid then
				GameTooltip:SetSpell(self.mendpetid,BOOKTYPE_SPELL)	
			else
				GameTooltip:SetText(BS["Mend Pet"], 1.0,1.0,1.0)		
			end
		elseif itemlink then
			GameTooltip:SetHyperlink(itemlink)
		else
			GameTooltip:SetText(L["No food available for your pet."], 1.0,1.0,1.0)
		end		
		GameTooltip:Show()
	end)

	self.feedButton:SetScript("OnLeave", function()
--~ 	added for SecureAnchorOnEnterTemplate, cause we define our own enter we need to make sure events get triggered
--~   	code copied from SecureTemplates.xml	
		self.feedButton:SetAttribute("_entered", nil);
		SecureStateAnchor_RunChild(self.feedButton, "OnLeave", "onleavebutton")
--~ 				
		GameTooltip:Hide()		
	end)
	
	self.feedButton:SetScript("PreClick", function()
		local itemlink = self:FeedPet()
		if not itemlink then									
			if UnitName("pet") then
				KingOfTheJungle:Chat(string.format(L["%s looks in your bags and sees no food in there."],UnitName("pet")))
			end
		end
	end)
	
--~ 	self.feedButton:SetScript("PostClick", function()
--~ 		self:HideFeedPetButton()	
--~ 	end)	
	
	self.feedButton:SetScript("OnDragStart", function()
		this:StartMoving()
	end)
	
	self.feedButton:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
		ValidateFramePosition(this)
		self.db.char.buttonPoint,_,_,self.db.char.buttonX,self.db.char.buttonY = this:GetPoint()
	end)
	
	local stateheadername = "KOTJSecureStateHeader"
	local hdr = _G[stateheadername]
	if(not hdr) then
		hdr = CreateFrame("Frame", stateheadername, self.feedButton, "SecureStateHeaderTemplate")
	end
	
	hdr:SetPoint("CENTER", 0, 0)
	
	hdr:SetAttribute("statemap-anchor-enter", "0:1")
	hdr:SetAttribute("statemap-anchor-leave", ";") 
	hdr:SetAttribute("delaystatemap-anchor-leave", "1:0")
	hdr:SetAttribute("delaytimemap-anchor-leave",  "1:1")
	hdr:SetAttribute("delayhovermap-anchor-leave", "1:true")
	
	self.feedButton:SetAttribute("anchorchild", hdr)
	
	local relpt = self.feedButton

	for i = 1,self.db.char.maxButtons do
		btn = FL:CreateFrame({frame = FL.UIOBJECT.BUTTON, name = "KOTJStateButton"..i, parent = hdr, tt = "", tttype = "Hyperlink", inherits = "SecureActionButtonTemplate,ActionButtonTemplate"})
		
		btn:SetAttribute("unit", "player")
		btn:SetAttribute("type", "spell")
		btn:SetAttribute("spell", BS["Feed Pet"])
		btn:SetAttribute("target-item", ATTRIBUTE_NOOP)

		if self.db.char.popupGrowthDir == FL.ANCHOR.TOP then
			btn:SetPoint(FL.ANCHOR.BOTTOM, relpt, FL.ANCHOR.TOP, 0, 5)
		elseif self.db.char.popupGrowthDir == FL.ANCHOR.BOTTOM then
			btn:SetPoint(FL.ANCHOR.TOP, relpt, FL.ANCHOR.BOTTOM, 0, -5)
		elseif self.db.char.popupGrowthDir == FL.ANCHOR.LEFT then
			btn:SetPoint(FL.ANCHOR.RIGHT, relpt, FL.ANCHOR.LEFT, -5, 0)
		elseif self.db.char.popupGrowthDir == FL.ANCHOR.RIGHT then
			btn:SetPoint(FL.ANCHOR.LEFT, relpt, FL.ANCHOR.RIGHT, 5, 0)
		end
		
		relpt = btn		
		-- Show in state 2, not we will never swap to state 2, state 2 acts as a hidden state for buttons
		-- State 1 will be for buttons that are visible, state 2 for buttons that should not be Shown
		-- state 0 is defaull all hide buttons state
		btn:SetAttribute("showstates", 2)
		-- Add the btn to the driver header
		hdr:SetAttribute("addchild", btn)
	end
					
	self:RegisterEvent("UNIT_HAPPINESS") 
	self:RegisterEvent("CHAT_MSG_SPELL_FAILED_LOCALPLAYER")	

	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("PLAYER_CONTROL_LOST")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
	
	self:RegisterEvent("UNIT_PET")
		
	local event = "CHAT_MSG_SPELL_TRADESKILLS"
	PL:RegisterEvent("KOTJ", event, function(event, info) 							
						if info.type == 'feedpet' and info.victim == ParserLib_SELF then	
							KingOfTheJungle:Chat(string.format(L["%s loves %s, mjummie."],UnitName("pet"),info.item))
						end
					end)
	
	self:RegisterEvent("UPDATE_BINDINGS")
	self:OverrideBindings()
	
	self:RegisterEvent("KOTJ_CheckForFeeding")
	
--~ 	self:ScheduleFeedingEvent()
	
	self:HideFeedPetButton()
end

function KingOfTheJungle:UPDATE_BINDINGS()
	if (not InCombatLockdown()) then
		self:OverrideBindings()		
	end
end

function KingOfTheJungle:UNIT_SPELLCAST_SUCCEEDED()
	if arg1 == "player" and arg2 == BS["Dismiss Pet"] then
		self:HideFeedPetButton()
	end	
	
	if arg1 == "player" and arg2 == BS["Revive Pet"] then
		self:HideFeedPetButton()
	end		
end

function KingOfTheJungle:PLAYER_CONTROL_LOST()
	self:HideFeedPetButton()
end

function KingOfTheJungle:PLAYER_REGEN_DISABLED()
	self.feedButton.texture:SetTexture("Interface\\Icons\\Ability_Hunter_MendPet")
	self.feedButton.texture:SetAllPoints(self.feedButton)
	self.feedButton.tooltip = BS["Mend Pet"]
	self.feedButton:SetAttribute("spell", BS["Mend Pet"])
	
	for i = 1,KingOfTheJungle.db.char.maxButtons do
		local buttonname = "KOTJStateButton"..i
		local btn = _G[buttonname]
		btn:SetAttribute("showstates", 2)
		btn:Hide()
	end
	
	self:HideFeedPetButton()	
end

function KingOfTheJungle:PLAYER_REGEN_ENABLED()
	self.feedButton.texture:SetTexture("Interface\\Icons\\Ability_Hunter_BeastTraining")
	self.feedButton.texture:SetAllPoints(self.feedButton)
	self.feedButton:SetAttribute("spell", BS["Feed Pet"])
	
	self:HideFeedPetButton()
end

function KingOfTheJungle:CHAT_MSG_SPELL_FAILED_LOCALPLAYER()
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: You are mounted."])) then
		KingOfTheJungle:Chat(string.format(L["%s thinks you should unmount before feeding him."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: Out of range."])) then
		KingOfTheJungle:Chat(string.format(L["%s likes to get closer with you before getting fed."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: That food's level is not high enough for your pet."])) then
		KingOfTheJungle:Chat(string.format(L["%s wants food of a more appropriate level."],UnitName("pet")))
	end
	if (arg1 and string.find(arg1, L["You fail to perform Feed Pet: Can't do that while stunned."])) then
		KingOfTheJungle:Chat(string.format(L["%s looks at you, wondering how you will feed him when you are stunned."],UnitName("pet")))
	end
end

function KingOfTheJungle:UNIT_HAPPINESS()	
	self:HideFeedPetButton()
end

function KingOfTheJungle:UNIT_PET()	
	if arg1 == "player" then
		self:HideFeedPetButton()
	end
end

function KingOfTheJungle:ScheduleFeedingEvent()
--~ 	if UnitHealth("pet") > 0 and not UnitIsDeadOrGhost("pet") and not InCombatLockdown() then	
		if not select(1,self:IsEventScheduled("KOTJEventFeedPet")) then		
			self:KOTJ_CheckForFeeding()
			self:ScheduleRepeatingEvent("KOTJEventFeedPet",self.KOTJ_CheckForFeeding, 15)		
		end
--~ 	end
end

function KingOfTheJungle:KOTJ_UpdateFeedPetButtons()
	local diets = {GetPetFoodTypes()}
	local buttoncount = 1
	local returnitemlink = nil
	local tmp_diet = nil 
	
	for i = 1,KingOfTheJungle.db.char.maxButtons do
		local buttonname = "KOTJStateButton"..i
		local btn = _G[buttonname]
		if btn then
			btn:SetAttribute("showstates", 2)
		end
	end
	
	for i,_ in ipairs(KingOfTheJungle.db.profile.foodlist) do
		if KingOfTheJungle.db.profile.foodlist[i]["selected"] then
			for idx, _ in ipairs(diets) do
				if L:HasReverseTranslation(diets[idx]) then
					tmp_diet = L:GetReverseTranslation(diets[idx])
				else
					tmp_diet = nil
					self:Debug("No reverse translation found for : ", diets[idx])
				end
				
				if tmp_diet and string.find(KingOfTheJungle.db.profile.foodlist[i]["diet"],tmp_diet) then 
					for index,_ in pairs(KingOfTheJungle.db.profile.foodlist[i]["list"]) do
						if buttoncount > KingOfTheJungle.db.char.maxButtons then
							if not returnitemlink then
								KingOfTheJungle.feedButton:SetAttribute("target-item", ATTRIBUTE_NOOP)
							end
							return returnitemlink
						end
						itemName, itemLink, _, itemLevel, _, _, _, _, _, itemTexture = GetItemInfo(KingOfTheJungle.db.profile.foodlist[i]["list"][index]["id"])
						if itemLink and GetItemCount(itemLink) > 0 and KingOfTheJungle.db.profile.foodlist[i]["list"][index]["selected"] then								
							if buttoncount == 1 then --Update smart feed button in first scan only
								KingOfTheJungle.feedButton:SetAttribute("target-item", itemName)
								returnitemlink = itemLink --Store itemlink so we can return it at the end
							end
							
							local buttonname = "KOTJStateButton"..buttoncount
							local btn = _G[buttonname]
							
							if btn then
								btn.texture = FL:CreateTexture({parent = btn, name = buttonname.."texture", layer = FL.LAYER.BACKGROUND, texture = itemTexture,
																setpoint = {frame = btn}})
								btn.count = FL:CreateFontString({parent = btn, name = buttonname.."count", layer = "ARTWORK", inherits = "GameFontNormal", justify = "LEFT",
									setpoint = {point = FL.ANCHOR.BOTTOMRIGHT, frame = btn, x = 0, y = 0}})								
								btn.count:SetText(GetItemCount(itemName))
								btn.tooltip = itemLink
								btn:SetAttribute("showstates", 1)
								
								btn:SetAttribute("target-item", itemName)
							end
							buttoncount = buttoncount + 1
						end
					end
				end
			end
		end
	end	
	if not returnitemlink then
		KingOfTheJungle.feedButton:SetAttribute("target-item", ATTRIBUTE_NOOP)
	end
	return returnitemlink
end

function KingOfTheJungle:KOTJ_CheckForFeeding()
--~     Number - the numerical happiness value of the pet (1 = unhappy, 2 = content, 3 = happy)
	local happiness, _, _ = GetPetHappiness()	
	
	if happiness and happiness <= KingOfTheJungle.db.char.petHappinessLevel then		
		if not KingOfTheJungle:CheckForBuffByPath(L["Feed Pet Effect"]) then
--~ 			local item = KingOfTheJungle:FeedPet()
			if KingOfTheJungle:FeedPet() then
				KingOfTheJungle.feedButton:Show()
				return
			else					
				if difftime(time(), KingOfTheJungle.db.char.lastWarningTime) > KingOfTheJungle.db.char.msgInterval then
					KingOfTheJungle.db.char.lastWarningTime = time()
					KingOfTheJungle:Chat(string.format(L["%s looks in your bags and sees no food in there."],UnitName("pet")))
				end
			end
		end		
	end	
	
	KingOfTheJungle:HideFeedPetButton()
end

function KingOfTheJungle:Chat(text)
	DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffeda55f %s |r", tostring(text)))	
end

function KingOfTheJungle:CheckForBuffByPath(texture)
	local i = 1	
	local _, _, buffTexture, _ = UnitBuff("pet",i)	
	while buffTexture do
		if string.find(texture, buffTexture) then
			return true
		end
		i = i + 1
		_, _, buffTexture, _ = UnitBuff("pet",i)
	end
	return false
end

function KingOfTheJungle:FeedPet()	
	return self:KOTJ_UpdateFeedPetButtons()
end

function KingOfTheJungle:HideFeedPetButton()
	-- Mend Pet requires persistent button to work.
	if self.db.char.enableMendPet then
		if InCombatLockdown() then
			self:CancelScheduledEvent("KOTJEventFeedPet")
		end
	else
		-- Show button when not in combat, pet is not happy and we have a pet
		if not InCombatLockdown() and GetPetHappiness() and GetPetHappiness() < 3 and UnitExists("pet") then
			self:ScheduleFeedingEvent()
			self.feedButton:Show()
		else
			self:CancelScheduledEvent("KOTJEventFeedPet")
			self.feedButton:Hide()
		end
	end
--~ Show button when in combat and mend pet is true and we have a pet
--~ 	self:Print("combat:"..tostring(InCombatLockdown())..",Pet:"..tostring(UnitExists("pet"))..",Happy:"..tostring(GetPetHappiness())..",MendPet:"..tostring(self.db.char.enableMendPet))
--~ Hide button when pet happiness is happy and we have a pet
--~ 	elseif not InCombatLockdown() and GetPetHappiness() and GetPetHappiness() == 3 and UnitExists("pet") then
--~ 		self:Print("Hide")
--~ 		self.feedButton:Hide()
--~ Show button when not in combat, revive/call pet is true and there is no pet
--~ Show button when not in combat, dismiss pet is true and there is a pet
end